<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  
  
  <link rel="shortcut icon" href="../img/favicon.ico">
  <title>LFortran Development Status - LFortran Documentation</title>
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Lato:400,700|Roboto+Slab:400,700|Inconsolata:400,700" />

  <link rel="stylesheet" href="../css/theme.css" />
  <link rel="stylesheet" href="../css/theme_extra.css" />
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/10.5.0/styles/github.min.css" />
  <link href="../ansi.css" rel="stylesheet" />
  
  <script>
    // Current page data
    var mkdocs_page_name = "LFortran Development Status";
    var mkdocs_page_input_path = "progress.md";
    var mkdocs_page_url = null;
  </script>
  
  <script src="../js/jquery-2.1.1.min.js" defer></script>
  <script src="../js/modernizr-2.8.3.min.js" defer></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/10.5.0/highlight.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/10.5.0/languages/fortran.min.js"></script>
  <script>hljs.initHighlightingOnLoad();</script> 
</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side stickynav">
    <div class="wy-side-scroll">
      <div class="wy-side-nav-search">
        <a href=".." class="icon icon-home"> LFortran Documentation</a>
        <div role="search">
  <form id ="rtd-search-form" class="wy-form" action="../search.html" method="get">
      <input type="text" name="q" placeholder="Search docs" title="Type search term here" />
  </form>
</div>
      </div>

      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
                <ul>
                    <li class="toctree-l1"><a class="reference internal" href="..">Home</a>
                    </li>
                </ul>
                <ul>
                    <li class="toctree-l1"><a class="reference internal" href="../installation/">Installation</a>
                    </li>
                </ul>
                <ul>
                    <li class="toctree-l1"><a class="reference internal" href="../language/">Fortran Language</a>
                    </li>
                </ul>
                <ul class="current">
                    <li class="toctree-l1 current"><a class="reference internal current" href="./">LFortran Development Status</a>
    <ul class="current">
    <li class="toctree-l2"><a class="reference internal" href="#development">Development</a>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#fortran-standards-supported">Fortran Standards Supported</a>
        <ul>
    <li class="toctree-l3"><a class="reference internal" href="#related-issues">Related Issues:</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#features-supported">Features Supported</a>
        <ul>
    <li class="toctree-l3"><a class="reference internal" href="#currently-supported">Currently Supported:</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#not-supportedcurrently-in-development">Not Supported/Currently in Development</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#related-issues_1">Related Issues</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#intrinsic-functions">Intrinsic Functions</a>
        <ul>
    <li class="toctree-l3"><a class="reference internal" href="#currently-supported_1">Currently Supported:</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#not-supportedcurrently-in-development_1">Not Supported/Currently in Development:</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#implementation-details">Implementation Details</a>
    </li>
        </ul>
    </li>
    </ul>
                    </li>
                </ul>
                <p class="caption"><span class="caption-text">Developer's Guide</span></p>
                <ul>
                    <li class="toctree-l1"><a class="reference internal" href="../design/">LFortran Design</a>
                    </li>
                    <li class="toctree-l1"><a class="" href="../developer_tutorial.md">None</a>
                    </li>
                    <li class="toctree-l1"><a class="" href="../AST and ASR.md">None</a>
                    </li>
                    <li class="toctree-l1"><a class="reference internal" href="../contribution/">Contributing</a>
                    </li>
                </ul>
      </div>
    </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="..">LFortran Documentation</a>
      </nav>

      
      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="..">Docs</a> &raquo;</li>
    
      
    
    <li>LFortran Development Status</li>
    <li class="wy-breadcrumbs-aside">
      
    </li>
  </ul>
  
  <hr/>
</div>

          <div role="main">
            <div class="section">
              
                <h1 id="lfortran-development-status">LFortran Development Status</h1>
<h2 id="development">Development</h2>
<p><strong>LFortran</strong> is currently under development and some of the features of Fortran might not be supported currently. The information regarding which functions are currently supported and which one's are still being worked on will be available in this section. You can submit any new issue you find while using LFortran to our <a href="https://gitlab.com/lfortran/lfortran/issues">issue tracker</a>. You can also check out any of the issues mentioned in the sections below and provide suggestions and ideas to help us get the feature implemented.</p>
<h2 id="fortran-standards-supported">Fortran Standards Supported</h2>
<p>LFortran currently supports a subset of the latest Fortran standard <a href="https://j3-fortran.org/doc/year/18/18-007r1.pdf">Fortran 2018 standard</a>. This document describes details about which features are supported and which are not.</p>
<h3 id="related-issues">Related Issues:</h3>
<ul>
<li><a href="https://gitlab.com/lfortran/lfortran/issues/120">#120</a></li>
</ul>
<h2 id="features-supported">Features Supported</h2>
<p>LFortran is currently in development and you might find some unsupported features while using it. We are working on fixing the issues and improving and expanding LFortran. You can also help out by reporting any new bug you find or you can check out any of the issues mentioned in the section and help us implement the feature faster.</p>
<h3 id="currently-supported">Currently Supported:</h3>
<ul>
<li>AST Generation</li>
<li>ASR Generation for most nodes</li>
<li>Fortran Modules</li>
<li>Functions</li>
<li>Subroutines</li>
<li>Basic data types like int, float, character</li>
<li>Binary Operations</li>
<li>Conditional and iterative statements</li>
<li>Printing</li>
</ul>
<h3 id="not-supportedcurrently-in-development">Not Supported/Currently in Development</h3>
<ul>
<li>Strings and Arrays</li>
<li>Nested Function Definitions</li>
<li>Complex Numbers</li>
<li>Optional Arguments</li>
<li>ASR not created for a few features supported by LFortran<ul>
<li>Conditional and iterative statements</li>
<li>Function Calls</li>
<li>Arithmetic assignment(like a = 10)</li>
<li>Assignments with binary operations including any number</li>
<li>Logical Variables</li>
<li>Print Statements</li>
<li>Some intrinsic Fortran Functions (see below)</li>
</ul>
</li>
</ul>
<h3 id="related-issues_1">Related Issues</h3>
<ul>
<li><a href="https://gitlab.com/lfortran/lfortran/issues/114">#114 Strings</a></li>
<li><a href="https://gitlab.com/lfortran/lfortran/issues/121">#121 ASR</a></li>
<li><a href="https://gitlab.com/lfortran/lfortran/issues/122">#122 Nested Function Definitions</a></li>
<li><a href="https://gitlab.com/lfortran/lfortran/issues/125">#125 Complex Numbers</a></li>
<li><a href="https://gitlab.com/lfortran/lfortran/issues/126">#126 Optional Arguments</a></li>
</ul>
<h2 id="intrinsic-functions">Intrinsic Functions</h2>
<p>LFortran does not support some of the standard intrinsic functions for the Fortran standard. Work is being done on having support for these functions. The testing for the functions is still being done. The list will be updated with the rest of the functions soon.</p>
<h3 id="currently-supported_1">Currently Supported:</h3>
<ul>
<li>log</li>
<li>sin</li>
<li>cos</li>
<li>tan</li>
<li>sinh</li>
<li>cosh</li>
<li>tanh</li>
</ul>
<h3 id="not-supportedcurrently-in-development_1">Not Supported/Currently in Development:</h3>
<ul>
<li>abs</li>
<li>sqrt</li>
<li>asin</li>
<li>acos</li>
<li>atan</li>
<li>exp</li>
<li>int</li>
<li>real</li>
<li>nint</li>
<li>floor</li>
<li>fraction</li>
<li>real</li>
<li>max</li>
<li>min</li>
<li>mod</li>
</ul>
<h3 id="implementation-details">Implementation Details</h3>
<p>This section is still subject to change. At the moment; the intrinsic functions are dispatched to <code>libm</code> and <code>glibc</code>. However, all functions are also being implemented so as to be usable from the Fortran runtime as well.</p>
              
            </div>
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="../design/" class="btn btn-neutral float-right" title="LFortran Design">Next <span class="icon icon-circle-arrow-right"></span></a>
      
      
        <a href="../language/" class="btn btn-neutral" title="Fortran Language"><span class="icon icon-circle-arrow-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <!-- Copyright etc -->
    
  </div>

  Built with <a href="https://www.mkdocs.org/">MkDocs</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>.
</footer>
      
        </div>
      </div>

    </section>

  </div>

  <div class="rst-versions" role="note" aria-label="versions">
  <span class="rst-current-version" data-toggle="rst-current-version">
    
    
      <span><a href="../language/" style="color: #fcfcfc">&laquo; Previous</a></span>
    
    
      <span><a href="../design/" style="color: #fcfcfc">Next &raquo;</a></span>
    
  </span>
</div>
    <script>var base_url = '..';</script>
    <script src="../js/theme_extra.js" defer></script>
    <script src="../js/theme.js" defer></script>
      <script src="../search/main.js" defer></script>
    <script defer>
        window.onload = function () {
            SphinxRtdTheme.Navigation.enable(true);
        };
    </script>

</body>
</html>
